<?php

declare(strict_types=1);

namespace Drupal\graphql_compose_webform\Plugin\GraphQLCompose\SchemaType;

use Drupal\graphql_compose\Plugin\GraphQLCompose\GraphQLComposeSchemaTypeBase;
use GraphQL\Type\Definition\ObjectType;
use GraphQL\Type\Definition\Type;

/**
 * {@inheritDoc}
 *
 * @GraphQLComposeSchemaType(
 *   id = "WebformSubmission"
 * )
 */
class WebformSubmission extends GraphQLComposeSchemaTypeBase {

  /**
   * {@inheritDoc}
   */
  public function getTypes(): array {
    $types = [];

    // Add the "WebformSubmission" type.
    $types[] = new ObjectType([
      'name' => $this->getPluginId(),
      'description' => (string) $this->t('A webform submission.'),
      'fields' => fn() => [
        'id' => Type::string(),
        'label' => Type::string(),
        'description' => Type::string(),
        'webform' => static::type('Webform'),
      ],
    ]);

    return $types;
  }

}
